diff --git a/gplugin/gplugin-manager.c b/gplugin/gplugin-manager.c
--- a/gplugin/gplugin-manager.c
+++ b/gplugin/gplugin-manager.c
@@ -1927,24 +1566,99 @@
  *               %FALSE otherwise.
  */
 gboolean
-gplugin_manager_load_plugin(GPluginPlugin *plugin, GError **error)
+gplugin_manager_load_plugin(
+	GPluginManager *manager,
+	GPluginPlugin *plugin,
+	GError **error)
 {
-	GPluginManagerClass *klass = NULL;
+	GPluginPluginInfo *info = NULL;
+	GPluginLoader *loader = NULL;
+	GError *real_error = NULL;
+	gboolean ret = TRUE;
 
+	g_return_val_if_fail(GPLUGIN_IS_MANAGER(manager), FALSE);
 	g_return_val_if_fail(GPLUGIN_IS_PLUGIN(plugin), FALSE);
 
-	g_return_val_if_fail(GPLUGIN_IS_MANAGER(instance), FALSE);
+	/* if the plugin is already loaded there's nothing for us to do */
+	if(gplugin_plugin_get_state(plugin) == GPLUGIN_PLUGIN_STATE_LOADED) {
+		return TRUE;
+	}
+
+	/* now try to get the plugin info from the plugin */
+	info = gplugin_plugin_get_info(plugin);
+	if(info == NULL) {
+		gchar *filename = gplugin_plugin_get_filename(plugin);
 
-	klass = GPLUGIN_MANAGER_GET_CLASS(instance);
-	if(klass && klass->load_plugin) {
-		return klass->load_plugin(instance, plugin, error);
+		g_set_error(
+			error,
+			GPLUGIN_DOMAIN,
+			0,
+			_("Plugin %s did not return value plugin info"),
+			filename);
+		g_free(filename);
+
+		gplugin_plugin_set_state(plugin, GPLUGIN_PLUGIN_STATE_LOAD_FAILED);
+
+		return FALSE;
+	}
+
+	if(!gplugin_manager_load_dependencies(manager, plugin, info, &real_error)) {
+		g_object_unref(G_OBJECT(info));
+
+		g_propagate_error(error, real_error);
+
+		return FALSE;
 	}
 
-	return FALSE;
+	g_object_unref(G_OBJECT(info));
+
+	/* now load the actual plugin */
+	loader = gplugin_plugin_get_loader(plugin);
+
+	if(!GPLUGIN_IS_LOADER(loader)) {
+		gchar *filename = gplugin_plugin_get_filename(plugin);
+
+		g_set_error(
+			error,
+			GPLUGIN_DOMAIN,
+			0,
+			_("The loader for %s is not a loader.  This "
+			  "should not happened!"),
+			filename);
+		g_free(filename);
+
+		gplugin_plugin_set_state(plugin, GPLUGIN_PLUGIN_STATE_LOAD_FAILED);
+
+		return FALSE;
+	}
+
+	g_signal_emit(manager, signals[SIG_LOADING], 0, plugin, &real_error, &ret);
+	if(!ret) {
+		/* Set the plugin's error. */
+		g_object_set(G_OBJECT(plugin), "error", real_error, NULL);
+
+		g_propagate_error(error, real_error);
+
+		gplugin_plugin_set_state(plugin, GPLUGIN_PLUGIN_STATE_LOAD_FAILED);
+
+		return ret;
+	}
+
+	ret = gplugin_loader_load_plugin(loader, plugin, &real_error);
+	if(ret) {
+		g_signal_emit(manager, signals[SIG_LOADED], 0, plugin);
+	} else {
+		g_signal_emit(manager, signals[SIG_LOAD_FAILED], 0, plugin);
+
+		g_propagate_error(error, real_error);
+	}
+
+	return ret;
 }
 
 /**
  * gplugin_manager_unload_plugin:
+ * @manager: The #GPluginManager instance.
  * @plugin: #GPluginPlugin instance.
  * @error: (out) (nullable): Return location for a #GError or %NULL.
  *
@@ -1954,24 +1668,67 @@
  *          otherwise.
  */
 gboolean
-gplugin_manager_unload_plugin(GPluginPlugin *plugin, GError **error)
+gplugin_manager_unload_plugin(
+	GPluginManager *manager,
+	GPluginPlugin *plugin,
+	GError **error)
 {
-	GPluginManagerClass *klass = NULL;
+	GPluginLoader *loader = NULL;
+	GError *real_error = NULL;
+	gboolean ret = TRUE;
 
+	g_return_val_if_fail(GPLUGIN_IS_MANAGER(manager), FALSE);
 	g_return_val_if_fail(GPLUGIN_IS_PLUGIN(plugin), FALSE);
 
-	g_return_val_if_fail(GPLUGIN_IS_MANAGER(instance), FALSE);
+	if(gplugin_plugin_get_state(plugin) != GPLUGIN_PLUGIN_STATE_LOADED) {
+		return TRUE;
+	}
 
-	klass = GPLUGIN_MANAGER_GET_CLASS(instance);
-	if(klass && klass->unload_plugin) {
-		return klass->unload_plugin(instance, plugin, error);
+	loader = gplugin_plugin_get_loader(plugin);
+	if(!GPLUGIN_IS_LOADER(loader)) {
+		g_set_error_literal(
+			error,
+			GPLUGIN_DOMAIN,
+			0,
+			_("Plugin loader is not a loader"));
+
+		return FALSE;
 	}
 
-	return FALSE;
+	g_signal_emit(
+		manager,
+		signals[SIG_UNLOADING],
+		0,
+		plugin,
+		&real_error,
+		&ret);
+	if(!ret) {
+		/* Set the plugin's error. */
+		g_object_set(G_OBJECT(plugin), "error", real_error, NULL);
+
+		g_propagate_error(error, real_error);
+
+		gplugin_plugin_set_state(plugin, GPLUGIN_PLUGIN_STATE_LOAD_FAILED);
+
+		return ret;
+	}
+
+	ret = gplugin_loader_unload_plugin(loader, plugin, &real_error);
+	if(ret) {
+		g_clear_error(&real_error);
+		g_signal_emit(manager, signals[SIG_UNLOADED], 0, plugin);
+	} else {
+		g_signal_emit(manager, signals[SIG_UNLOAD_FAILED], 0, plugin);
+
+		g_propagate_error(error, real_error);
+	}
+
+	return ret;
 }
 
 /**
  * gplugin_manager_list_plugins:
+ * @manager: The #GPluginManager instance.
  *
  * Returns a #GList of all plugin id's.  Each id should be queried directly
  * for more information.
@@ -1980,34 +1737,42 @@
  *               unique plugin id.
  */
 GList *
-gplugin_manager_list_plugins(void)
+gplugin_manager_list_plugins(GPluginManager *manager)
 {
-	GPluginManagerClass *klass = NULL;
+	GPluginManagerPrivate *priv = NULL;
+	GQueue *queue = NULL;
+	GList *ret = NULL;
+	GHashTableIter iter;
+	gpointer key = NULL;
 
-	g_return_val_if_fail(GPLUGIN_IS_MANAGER(instance), NULL);
+	g_return_val_if_fail(GPLUGIN_IS_MANAGER(manager), NULL);
 
-	klass = GPLUGIN_MANAGER_GET_CLASS(instance);
-	if(klass && klass->list_plugins) {
-		return klass->list_plugins(instance);
+	priv = gplugin_manager_get_instance_private(manager);
+	queue = g_queue_new();
+
+	g_hash_table_iter_init(&iter, priv->plugins);
+	while(g_hash_table_iter_next(&iter, &key, NULL)) {
+		g_queue_push_tail(queue, (gchar *)key);
 	}
 
-	return NULL;
+	ret = g_list_copy(queue->head);
+
+	g_queue_free(queue);
+
+	return ret;
 }
 
 /**
- * gplugin_manager_get_instance:
+ * gplugin_manager_get_default:
  *
- * Returns a #GObject that is the instance of the plugin manager that is being
- * used.
+ * Gets the default #GPluginManager in GPlugin.
  *
- * This is provided so that signals can be connected and should not be tinkered
- * with in any way.
+ * Returns: (transfer none): The default GPluginManager instance.
  *
- * Returns: (transfer none): The #GObject that is the instance of the plugin
- *                           manager.
+ * Since: 0.33.0
  */
 GPluginManager *
-gplugin_manager_get_instance(void)
+gplugin_manager_get_default(void)
 {
-	return instance;
+	return default_manager;
 }
diff --git a/gplugin/gplugin-options.c b/gplugin/gplugin-options.c
--- a/gplugin/gplugin-options.c
+++ b/gplugin/gplugin-options.c
@@ -91,6 +91,7 @@
 	G_GNUC_UNUSED gpointer data,
 	G_GNUC_UNUSED GError **error)
 {
+	GPluginManager *manager = NULL;
 	GPluginCoreFlags flags = GPLUGIN_CORE_FLAGS_NONE;
 
 	if(!register_native_loader) {
@@ -99,15 +100,17 @@
 
 	gplugin_init(flags);
 
+	manager = gplugin_manager_get_default();
+
 	if(add_default_paths) {
-		gplugin_manager_add_default_paths();
+		gplugin_manager_add_default_paths(manager);
 	}
 
 	if(paths != NULL) {
 		guint i = 0;
 
 		for(i = 0; paths[i] != NULL; i++) {
-			gplugin_manager_prepend_path(paths[i]);
+			gplugin_manager_prepend_path(manager, paths[i]);
 		}
 
 		g_clear_pointer(&paths, g_strfreev);
diff --git a/gplugin/tests/test-bind-global.c b/gplugin/tests/test-bind-global.c
--- a/gplugin/tests/test-bind-global.c
+++ b/gplugin/tests/test-bind-global.c
@@ -33,13 +33,14 @@
 static void
 test_bind_global(void)
 {
+	GPluginManager *manager = gplugin_manager_get_default();
 	GPluginPlugin *plugin = NULL;
 
-	gplugin_manager_remove_paths();
-	gplugin_manager_append_path(TEST_BIND_GLOBAL_DIR);
-	gplugin_manager_refresh();
+	gplugin_manager_remove_paths(manager);
+	gplugin_manager_append_path(manager, TEST_BIND_GLOBAL_DIR);
+	gplugin_manager_refresh(manager);
 
-	plugin = gplugin_manager_find_plugin("gplugin/bind-global");
+	plugin = gplugin_manager_find_plugin(manager, "gplugin/bind-global");
 	g_assert_nonnull(plugin);
 	g_assert_true(GPLUGIN_IS_PLUGIN(plugin));
 	g_assert_true(GPLUGIN_IS_NATIVE_PLUGIN(plugin));
diff --git a/gplugin/tests/test-core.c b/gplugin/tests/test-core.c
--- a/gplugin/tests/test-core.c
+++ b/gplugin/tests/test-core.c
@@ -25,17 +25,18 @@
 static void
 test_gplugin_count_ids_and_plugins(gint *n_ids, gint *n_plugins)
 {
+	GPluginManager *manager = gplugin_manager_get_default();
 	GList *l_ids = NULL, *l_id = NULL;
 	gint ids = 0, plugins = 0;
 
-	l_ids = gplugin_manager_list_plugins();
+	l_ids = gplugin_manager_list_plugins(manager);
 	for(l_id = l_ids; l_id; l_id = l_id->next) {
 		GSList *l_plugins = NULL, *l_plugin = NULL;
 		const gchar *id = (const gchar *)l_id->data;
 
 		ids += 1;
 
-		l_plugins = gplugin_manager_find_plugins(id);
+		l_plugins = gplugin_manager_find_plugins(manager, id);
 		for(l_plugin = l_plugins; l_plugin; l_plugin = l_plugin->next) {
 			plugins += 1;
 		}
@@ -73,35 +74,49 @@
 static void
 test_gplugin_init_uninit_with_refresh(void)
 {
+	GPluginManager *manager = NULL;
+
 	gplugin_init(GPLUGIN_CORE_FLAGS_NONE);
-	gplugin_manager_refresh();
+
+	manager = gplugin_manager_get_default();
+	gplugin_manager_refresh(manager);
+
 	gplugin_uninit();
 }
 
 static void
 test_gplugin_init_uninit_with_refresh_plugins(void)
 {
+	GPluginManager *manager = NULL;
+
 	gplugin_init(GPLUGIN_CORE_FLAGS_NONE);
-	gplugin_manager_append_path(TEST_DIR);
-	gplugin_manager_refresh();
+
+	manager = gplugin_manager_get_default();
+	gplugin_manager_append_path(manager, TEST_DIR);
+	gplugin_manager_refresh(manager);
+
 	gplugin_uninit();
 }
 
 static void
 test_gplugin_init_uninit_with_double_refresh_plugins(void)
 {
+	GPluginManager *manager = NULL;
 	gint f_ids = 0, s_ids = 0, f_plugins = 0, s_plugins = 0;
 
 	gplugin_init(GPLUGIN_CORE_FLAGS_NONE);
-	gplugin_manager_append_path(TEST_DIR);
-	gplugin_manager_append_path(TEST_ID_DIR);
+
+	manager = gplugin_manager_get_default();
+
+	gplugin_manager_append_path(manager, TEST_DIR);
+	gplugin_manager_append_path(manager, TEST_ID_DIR);
 
 	/* run the first refresh and count everything */
-	gplugin_manager_refresh();
+	gplugin_manager_refresh(manager);
 	test_gplugin_count_ids_and_plugins(&f_ids, &f_plugins);
 
 	/* now run the second refresh and make sure the counts match */
-	gplugin_manager_refresh();
+	gplugin_manager_refresh(manager);
 	test_gplugin_count_ids_and_plugins(&s_ids, &s_plugins);
 
 	g_assert_cmpint(f_ids, >, 0);
@@ -116,9 +131,13 @@
 static void
 test_gplugin_init_no_native_loader(void)
 {
+	GPluginManager *manager = NULL;
+
 	gplugin_init(GPLUGIN_CORE_FLAGS_DISABLE_NATIVE_LOADER);
 
-	g_assert_null(gplugin_manager_get_loaders());
+	manager = gplugin_manager_get_default();
+
+	g_assert_null(gplugin_manager_get_loaders(manager));
 
 	gplugin_uninit();
 }
diff --git a/gplugin/tests/test-dynamic-type.c b/gplugin/tests/test-dynamic-type.c
--- a/gplugin/tests/test-dynamic-type.c
+++ b/gplugin/tests/test-dynamic-type.c
@@ -29,28 +29,30 @@
 static void
 test_dynamic_type(void)
 {
+	GPluginManager *manager = gplugin_manager_get_default();
 	GPluginPlugin *provider = NULL, *user = NULL;
 	GPluginPluginState state;
 	GError *error = NULL;
 	gboolean ret = FALSE;
 
-	gplugin_manager_append_path(TEST_DYNAMIC_DIR);
-	gplugin_manager_refresh();
+	gplugin_manager_append_path(manager, TEST_DYNAMIC_DIR);
+	gplugin_manager_refresh(manager);
 
-	provider = gplugin_manager_find_plugin("gplugin/dynamic-type-provider");
+	provider =
+		gplugin_manager_find_plugin(manager, "gplugin/dynamic-type-provider");
 
 	g_assert_nonnull(provider);
-	ret = gplugin_manager_load_plugin(provider, &error);
+	ret = gplugin_manager_load_plugin(manager, provider, &error);
 	g_assert_no_error(error);
 	g_assert_true(ret);
 
 	state = gplugin_plugin_get_state(provider);
 	g_assert_cmpint(state, ==, GPLUGIN_PLUGIN_STATE_LOADED);
 
-	user = gplugin_manager_find_plugin("gplugin/dynamic-type-user");
+	user = gplugin_manager_find_plugin(manager, "gplugin/dynamic-type-user");
 
 	g_assert_nonnull(user);
-	ret = gplugin_manager_load_plugin(user, &error);
+	ret = gplugin_manager_load_plugin(manager, user, &error);
 	g_assert_no_error(error);
 	g_assert_true(ret);
 
@@ -58,14 +60,14 @@
 	g_assert_cmpint(state, ==, GPLUGIN_PLUGIN_STATE_LOADED);
 
 	/* now unload the plugin */
-	ret = gplugin_manager_unload_plugin(user, &error);
+	ret = gplugin_manager_unload_plugin(manager, user, &error);
 	g_assert_no_error(error);
 	g_assert_true(ret);
 
 	state = gplugin_plugin_get_state(user);
 	g_assert_cmpint(state, ==, GPLUGIN_PLUGIN_STATE_QUERIED);
 
-	ret = gplugin_manager_unload_plugin(provider, &error);
+	ret = gplugin_manager_unload_plugin(manager, provider, &error);
 	g_assert_no_error(error);
 	g_assert_true(ret);
 
diff --git a/gplugin/tests/test-find-plugins.c b/gplugin/tests/test-find-plugins.c
--- a/gplugin/tests/test-find-plugins.c
+++ b/gplugin/tests/test-find-plugins.c
@@ -28,10 +28,11 @@
 	GSList *plugins,
 	gpointer data)
 {
+	GPluginManager *manager = gplugin_manager_get_default();
 	GSList *l = NULL;
 
 	for(l = plugins; l != NULL; l = l->next) {
-		gplugin_manager_load_plugin(GPLUGIN_PLUGIN(l->data), NULL);
+		gplugin_manager_load_plugin(manager, GPLUGIN_PLUGIN(l->data), NULL);
 	}
 }
 
@@ -41,10 +42,11 @@
 	GSList *plugins,
 	gpointer data)
 {
+	GPluginManager *manager = gplugin_manager_get_default();
 	GSList *l = NULL;
 
 	for(l = plugins; l != NULL; l = l->next) {
-		gplugin_manager_unload_plugin(GPLUGIN_PLUGIN(l->data), NULL);
+		gplugin_manager_unload_plugin(manager, GPLUGIN_PLUGIN(l->data), NULL);
 	}
 }
 
@@ -64,6 +66,7 @@
 static void
 test_gplugin_manager_find_plugins_with_state(void)
 {
+	GPluginManager *manager = NULL;
 	GSList *plugins = NULL;
 
 	/* this is the list of the current plugins and the furthest state they can
@@ -84,41 +87,54 @@
 
 	gplugin_init(GPLUGIN_CORE_FLAGS_NONE);
 
-	gplugin_manager_append_path(TEST_DIR);
-	gplugin_manager_refresh();
+	manager = gplugin_manager_get_default();
+
+	gplugin_manager_append_path(manager, TEST_DIR);
+	gplugin_manager_refresh(manager);
 
 	/* make sure that all the plugins are queried */
-	plugins =
-		gplugin_manager_find_plugins_with_state(GPLUGIN_PLUGIN_STATE_QUERIED);
+	plugins = gplugin_manager_find_plugins_with_state(
+		manager,
+		GPLUGIN_PLUGIN_STATE_QUERIED);
 	g_assert_cmpint(g_slist_length(plugins), ==, QUERIED);
 	g_slist_free_full(plugins, g_object_unref);
 
 	/* now load all of the plugins */
-	gplugin_manager_foreach(test_gplugin_manager_foreach_load_plugins, NULL);
+	gplugin_manager_foreach(
+		manager,
+		test_gplugin_manager_foreach_load_plugins,
+		NULL);
 
 	/* make sure we have the proper number loaded */
-	plugins =
-		gplugin_manager_find_plugins_with_state(GPLUGIN_PLUGIN_STATE_LOADED);
+	plugins = gplugin_manager_find_plugins_with_state(
+		manager,
+		GPLUGIN_PLUGIN_STATE_LOADED);
 	g_assert_cmpint(g_slist_length(plugins), ==, LOADED);
 	g_slist_free_full(plugins, g_object_unref);
 
 	/* make sure we have the proper number of load failed */
 	plugins = gplugin_manager_find_plugins_with_state(
+		manager,
 		GPLUGIN_PLUGIN_STATE_LOAD_FAILED);
 	g_assert_cmpint(g_slist_length(plugins), ==, LOAD_FAILED);
 	g_slist_free_full(plugins, g_object_unref);
 
 	/* unload all of the plugins */
-	gplugin_manager_foreach(test_gplugin_manager_foreach_unload_plugins, NULL);
+	gplugin_manager_foreach(
+		manager,
+		test_gplugin_manager_foreach_unload_plugins,
+		NULL);
 
 	/* make sure we have the proper number unloaded */
-	plugins =
-		gplugin_manager_find_plugins_with_state(GPLUGIN_PLUGIN_STATE_QUERIED);
+	plugins = gplugin_manager_find_plugins_with_state(
+		manager,
+		GPLUGIN_PLUGIN_STATE_QUERIED);
 	g_assert_cmpint(g_slist_length(plugins), ==, UNLOADED);
 	g_slist_free_full(plugins, g_object_unref);
 
 	/* make sure we have the proper number of unload failed */
 	plugins = gplugin_manager_find_plugins_with_state(
+		manager,
 		GPLUGIN_PLUGIN_STATE_UNLOAD_FAILED);
 	g_assert_cmpint(g_slist_length(plugins), ==, UNLOAD_FAILED);
 	g_slist_free_full(plugins, g_object_unref);
diff --git a/gplugin/tests/test-id-collision.c b/gplugin/tests/test-id-collision.c
--- a/gplugin/tests/test-id-collision.c
+++ b/gplugin/tests/test-id-collision.c
@@ -29,12 +29,15 @@
 static void
 test_id_collision(void)
 {
+	GPluginManager *manager = NULL;
 	GSList *plugins = NULL;
 
-	gplugin_manager_append_path(TEST_ID_DIR);
-	gplugin_manager_refresh();
+	manager = gplugin_manager_get_default();
 
-	plugins = gplugin_manager_find_plugins("gplugin/id-collision");
+	gplugin_manager_append_path(manager, TEST_ID_DIR);
+	gplugin_manager_refresh(manager);
+
+	plugins = gplugin_manager_find_plugins(manager, "gplugin/id-collision");
 	g_assert_nonnull(plugins);
 
 	g_assert_cmpuint(g_slist_length(plugins), ==, 2);
@@ -48,7 +51,6 @@
 gint
 main(gint argc, gchar **argv)
 {
-
 	g_test_init(&argc, &argv, NULL);
 
 	gplugin_init(GPLUGIN_CORE_FLAGS_NONE);
diff --git a/gplugin/tests/test-load-on-query.c b/gplugin/tests/test-load-on-query.c
--- a/gplugin/tests/test-load-on-query.c
+++ b/gplugin/tests/test-load-on-query.c
@@ -29,13 +29,14 @@
 static void
 test_load_on_query(void)
 {
+	GPluginManager *manager = gplugin_manager_get_default();
 	GPluginPlugin *plugin = NULL;
 
-	gplugin_manager_remove_paths();
-	gplugin_manager_append_path(TEST_LOAD_ON_QUERY_PASS_DIR);
-	gplugin_manager_refresh();
+	gplugin_manager_remove_paths(manager);
+	gplugin_manager_append_path(manager, TEST_LOAD_ON_QUERY_PASS_DIR);
+	gplugin_manager_refresh(manager);
 
-	plugin = gplugin_manager_find_plugin("gplugin/load-on-query");
+	plugin = gplugin_manager_find_plugin(manager, "gplugin/load-on-query");
 	g_assert_nonnull(plugin);
 	g_assert_true(GPLUGIN_IS_PLUGIN(plugin));
 
@@ -48,6 +49,8 @@
 static void
 test_load_on_query_fail_subprocess(void)
 {
+	GPluginManager *manager = gplugin_manager_get_default();
+
 	/* this test is very simple since we can't get the exact error condition
 	 * that we want.
 	 *
@@ -57,10 +60,10 @@
 	 * plugin stored twice.  This has been fixed in the code, but it has to be
 	 * looked for manually.
 	 */
-	gplugin_manager_remove_paths();
-	gplugin_manager_append_path(TEST_DIR);
-	gplugin_manager_append_path(TEST_LOAD_ON_QUERY_FAIL_DIR);
-	gplugin_manager_refresh();
+	gplugin_manager_remove_paths(manager);
+	gplugin_manager_append_path(manager, TEST_DIR);
+	gplugin_manager_append_path(manager, TEST_LOAD_ON_QUERY_FAIL_DIR);
+	gplugin_manager_refresh(manager);
 }
 
 static void
diff --git a/gplugin/tests/test-loader-registration.c b/gplugin/tests/test-loader-registration.c
--- a/gplugin/tests/test-loader-registration.c
+++ b/gplugin/tests/test-loader-registration.c
@@ -94,17 +94,26 @@
 static void
 test_gplugin_manager_loader_register_unregister(void)
 {
+	GPluginManager *manager = NULL;
 	GError *error = NULL;
 	gboolean ret;
 
 	gplugin_manager_private_uninit();
 	gplugin_manager_private_init(TRUE);
 
-	ret = gplugin_manager_register_loader(TEST_GPLUGIN_TYPE_LOADER, &error);
+	manager = gplugin_manager_get_default();
+
+	ret = gplugin_manager_register_loader(
+		manager,
+		TEST_GPLUGIN_TYPE_LOADER,
+		&error);
 	g_assert_no_error(error);
 	g_assert_true(ret);
 
-	ret = gplugin_manager_unregister_loader(TEST_GPLUGIN_TYPE_LOADER, &error);
+	ret = gplugin_manager_unregister_loader(
+		manager,
+		TEST_GPLUGIN_TYPE_LOADER,
+		&error);
 	g_assert_no_error(error);
 	g_assert_true(ret);
 }
@@ -112,22 +121,34 @@
 static void
 test_gplugin_manager_loader_register_twice(void)
 {
+	GPluginManager *manager = NULL;
 	GError *error = NULL;
 	gboolean ret;
 
 	gplugin_manager_private_uninit();
 	gplugin_manager_private_init(TRUE);
 
-	ret = gplugin_manager_register_loader(TEST_GPLUGIN_TYPE_LOADER, &error);
+	manager = gplugin_manager_get_default();
+
+	ret = gplugin_manager_register_loader(
+		manager,
+		TEST_GPLUGIN_TYPE_LOADER,
+		&error);
 	g_assert_no_error(error);
 	g_assert_true(ret);
 
-	ret = gplugin_manager_register_loader(TEST_GPLUGIN_TYPE_LOADER, &error);
+	ret = gplugin_manager_register_loader(
+		manager,
+		TEST_GPLUGIN_TYPE_LOADER,
+		&error);
 	g_assert_false(ret);
 	g_assert_error(error, GPLUGIN_DOMAIN, 0);
 	g_clear_error(&error);
 
-	ret = gplugin_manager_unregister_loader(TEST_GPLUGIN_TYPE_LOADER, &error);
+	ret = gplugin_manager_unregister_loader(
+		manager,
+		TEST_GPLUGIN_TYPE_LOADER,
+		&error);
 	g_assert_no_error(error);
 	g_assert_true(ret);
 }
@@ -135,21 +156,33 @@
 static void
 test_gplugin_manager_loader_unregister_twice(void)
 {
+	GPluginManager *manager = NULL;
 	GError *error = NULL;
 	gboolean ret;
 
 	gplugin_manager_private_uninit();
 	gplugin_manager_private_init(TRUE);
 
-	ret = gplugin_manager_register_loader(TEST_GPLUGIN_TYPE_LOADER, &error);
+	manager = gplugin_manager_get_default();
+
+	ret = gplugin_manager_register_loader(
+		manager,
+		TEST_GPLUGIN_TYPE_LOADER,
+		&error);
 	g_assert_no_error(error);
 	g_assert_true(ret);
 
-	ret = gplugin_manager_unregister_loader(TEST_GPLUGIN_TYPE_LOADER, &error);
+	ret = gplugin_manager_unregister_loader(
+		manager,
+		TEST_GPLUGIN_TYPE_LOADER,
+		&error);
 	g_assert_no_error(error);
 	g_assert_true(ret);
 
-	ret = gplugin_manager_unregister_loader(TEST_GPLUGIN_TYPE_LOADER, &error);
+	ret = gplugin_manager_unregister_loader(
+		manager,
+		TEST_GPLUGIN_TYPE_LOADER,
+		&error);
 	g_assert_false(ret);
 	g_assert_error(error, GPLUGIN_DOMAIN, 0);
 	g_clear_error(&error);
diff --git a/gplugin/tests/test-native-loader.c b/gplugin/tests/test-native-loader.c
--- a/gplugin/tests/test-native-loader.c
+++ b/gplugin/tests/test-native-loader.c
@@ -29,26 +29,28 @@
 static void
 test_broken_depend_plugin_load(void)
 {
+	GPluginManager *manager = gplugin_manager_get_default();
 	GPluginPlugin *plugin = NULL;
 	GPluginPluginState state;
 	GError *error = NULL;
 
 	/* add the test directory to the plugin manager's search paths */
-	gplugin_manager_append_path(TEST_DIR);
+	gplugin_manager_append_path(manager, TEST_DIR);
 
 	/* refresh the plugin manager */
-	gplugin_manager_refresh();
+	gplugin_manager_refresh(manager);
 
 	/* find the dependent plugin and make sure it isn't loaded */
-	plugin =
-		gplugin_manager_find_plugin("gplugin/broken-dependent-native-plugin");
+	plugin = gplugin_manager_find_plugin(
+		manager,
+		"gplugin/broken-dependent-native-plugin");
 	g_assert_nonnull(plugin);
 
 	state = gplugin_plugin_get_state(plugin);
 	g_assert_cmpint(state, !=, GPLUGIN_PLUGIN_STATE_LOADED);
 
 	/* now attempt to load the dependent plugin, it's supposed to fail */
-	g_assert_false(gplugin_manager_load_plugin(plugin, &error));
+	g_assert_false(gplugin_manager_load_plugin(manager, plugin, &error));
 	g_assert_error(error, GPLUGIN_DOMAIN, 0);
 	g_error_free(error);
 }
@@ -59,16 +61,17 @@
 static void
 test_query_error_subprocess(void)
 {
+	GPluginManager *manager = gplugin_manager_get_default();
 	GPluginPlugin *plugin = NULL;
 
 	/* add the test directory to the plugin manager's search paths */
-	gplugin_manager_append_path(TEST_BAD_DIR);
+	gplugin_manager_append_path(manager, TEST_BAD_DIR);
 
 	/* refresh the plugin manager */
-	gplugin_manager_refresh();
+	gplugin_manager_refresh(manager);
 
 	/* find the query-error plugin */
-	plugin = gplugin_manager_find_plugin("gplugin/query-error");
+	plugin = gplugin_manager_find_plugin(manager, "gplugin/query-error");
 	g_assert_null(plugin);
 }
 
diff --git a/gplugin/tests/test-newest-version.c b/gplugin/tests/test-newest-version.c
--- a/gplugin/tests/test-newest-version.c
+++ b/gplugin/tests/test-newest-version.c
@@ -25,13 +25,14 @@
 static void
 test_newest_version(const gchar *id, const gchar *version)
 {
+	GPluginManager *manager = gplugin_manager_get_default();
 	GPluginPlugin *plugin = NULL;
 	GPluginPluginInfo *info = NULL;
 
-	gplugin_manager_append_path(TEST_DIR);
-	gplugin_manager_refresh();
+	gplugin_manager_append_path(manager, TEST_DIR);
+	gplugin_manager_refresh(manager);
 
-	plugin = gplugin_manager_find_plugin_with_newest_version(id);
+	plugin = gplugin_manager_find_plugin_with_newest_version(manager, id);
 	g_assert_nonnull(plugin);
 	g_assert_true(GPLUGIN_IS_PLUGIN(plugin));
 
diff --git a/gplugin/tests/test-option-group.c b/gplugin/tests/test-option-group.c
--- a/gplugin/tests/test-option-group.c
+++ b/gplugin/tests/test-option-group.c
@@ -25,6 +25,7 @@
 static void
 test_gplugin_option_group_paths(const gchar *args, GList *expected)
 {
+	GPluginManager *manager = NULL;
 	GError *error = NULL;
 	GOptionContext *ctx = NULL;
 	GOptionGroup *group = NULL;
@@ -41,7 +42,12 @@
 
 	g_strfreev(argv);
 
-	paths = gplugin_manager_get_paths();
+	/* the above gplugin_get_option_group will call gplugin_init if it hasn't
+	 * been called yet. Untill gplugin_init is called manager will be NULL.
+	 */
+	manager = gplugin_manager_get_default();
+
+	paths = gplugin_manager_get_paths(manager);
 	paths = g_list_sort(paths, g_str_equal);
 
 	expected = g_list_sort(expected, g_str_equal); //-V522
diff --git a/gplugin/tests/test-plugin-manager-paths.c b/gplugin/tests/test-plugin-manager-paths.c
--- a/gplugin/tests/test-plugin-manager-paths.c
+++ b/gplugin/tests/test-plugin-manager-paths.c
@@ -22,7 +22,8 @@
 #define test_path_count(e) \
 	G_STMT_START \
 		{ \
-			GList *paths = gplugin_manager_get_paths(); \
+			GPluginManager *manager = gplugin_manager_get_default(); \
+			GList *paths = gplugin_manager_get_paths(manager); \
 			g_assert_cmpint(g_list_length(paths), ==, (e)); \
 		} \
 	G_STMT_END
@@ -33,100 +34,113 @@
 static void
 test_gplugin_manager_paths_single(void)
 {
-	gplugin_manager_append_path("foo");
+	GPluginManager *manager = gplugin_manager_get_default();
+
+	gplugin_manager_append_path(manager, "foo");
 	test_path_count(1);
 
-	gplugin_manager_remove_path("foo");
+	gplugin_manager_remove_path(manager, "foo");
 	test_path_count(0);
 }
 
 static void
 test_gplugin_manager_paths_duplicate(void)
 {
-	gplugin_manager_append_path("foo");
-	gplugin_manager_append_path("foo");
+	GPluginManager *manager = gplugin_manager_get_default();
+
+	gplugin_manager_append_path(manager, "foo");
+	gplugin_manager_append_path(manager, "foo");
 
 	test_path_count(1);
 
-	gplugin_manager_remove_path("foo");
+	gplugin_manager_remove_path(manager, "foo");
 	test_path_count(0);
 }
 
 static void
 test_gplugin_manager_paths_multiple_fifo(void)
 {
+	GPluginManager *manager = gplugin_manager_get_default();
+
 	/* add */
-	gplugin_manager_append_path("foo");
+	gplugin_manager_append_path(manager, "foo");
 	test_path_count(1);
 
-	gplugin_manager_append_path("bar");
+	gplugin_manager_append_path(manager, "bar");
 	test_path_count(2);
 
 	/* remove */
-	gplugin_manager_remove_path("foo");
+	gplugin_manager_remove_path(manager, "foo");
 	test_path_count(1);
 
-	gplugin_manager_remove_path("bar");
+	gplugin_manager_remove_path(manager, "bar");
 	test_path_count(0);
 }
 
 static void
 test_gplugin_manager_paths_multiple_filo(void)
 {
+	GPluginManager *manager = gplugin_manager_get_default();
+
 	/* add */
-	gplugin_manager_append_path("foo");
+	gplugin_manager_append_path(manager, "foo");
 	test_path_count(1);
 
-	gplugin_manager_append_path("bar");
+	gplugin_manager_append_path(manager, "bar");
 	test_path_count(2);
 
 	/* remove */
-	gplugin_manager_remove_path("bar");
+	gplugin_manager_remove_path(manager, "bar");
 	test_path_count(1);
 
-	gplugin_manager_remove_path("foo");
+	gplugin_manager_remove_path(manager, "foo");
 	test_path_count(0);
 }
 
 static void
 test_gplugin_manager_paths_unicode(void)
 {
+	GPluginManager *manager = gplugin_manager_get_default();
+
 	test_path_count(0);
 
-	gplugin_manager_append_path("/home/🐦/.plugins");
+	gplugin_manager_append_path(manager, "/home/🐦/.plugins");
 	test_path_count(1);
 
-	gplugin_manager_append_path("/home/user/.plugins");
+	gplugin_manager_append_path(manager, "/home/user/.plugins");
 	test_path_count(2);
 
-	gplugin_manager_remove_path("/home/🐦/.plugins");
+	gplugin_manager_remove_path(manager, "/home/🐦/.plugins");
 	test_path_count(1);
 
-	gplugin_manager_remove_path("/home/user/.plugins");
+	gplugin_manager_remove_path(manager, "/home/user/.plugins");
 	test_path_count(0);
 }
 
 static void
 test_gplugin_manager_add_multiple_mixed_trailing_slashes(void)
 {
+	GPluginManager *manager = gplugin_manager_get_default();
+
 	test_path_count(0);
 
-	gplugin_manager_append_path("/home/user1/.plugins");
+	gplugin_manager_append_path(manager, "/home/user1/.plugins");
 	test_path_count(1);
 
-	gplugin_manager_append_path("/home/user2/.plugins/");
+	gplugin_manager_append_path(manager, "/home/user2/.plugins/");
 	test_path_count(2);
 
-	gplugin_manager_remove_path("/home/user1/.plugins/");
+	gplugin_manager_remove_path(manager, "/home/user1/.plugins/");
 	test_path_count(1);
 
-	gplugin_manager_remove_path("/home/user2/.plugins");
+	gplugin_manager_remove_path(manager, "/home/user2/.plugins");
 	test_path_count(0);
 }
 
 static void
 test_gplugin_manager_add_default_paths(void)
 {
+	GPluginManager *manager = gplugin_manager_get_default();
 	GHashTable *req = NULL;
 	GList *paths = NULL, *l = NULL;
 	gchar *path = NULL;
@@ -147,10 +161,10 @@
 	g_hash_table_insert(req, path, GINT_TO_POINTER(FALSE));
 
 	/* now tell the plugin manager to add the default paths */
-	gplugin_manager_add_default_paths();
+	gplugin_manager_add_default_paths(manager);
 
 	/* now remove each path that the manager knows about from our table */
-	paths = gplugin_manager_get_paths();
+	paths = gplugin_manager_get_paths(manager);
 	for(l = paths; l; l = l->next) {
 		g_hash_table_remove(req, l->data);
 	}
@@ -165,6 +179,7 @@
 static void
 test_gplugin_manager_add_app_paths(void)
 {
+	GPluginManager *manager = gplugin_manager_get_default();
 	GHashTable *req = NULL;
 	GList *paths = NULL, *l = NULL;
 	const gchar *prefix = "/usr/local/";
@@ -187,12 +202,12 @@
 	g_hash_table_insert(req, path, GINT_TO_POINTER(FALSE));
 
 	/* now add the app paths */
-	gplugin_manager_add_app_paths(prefix, "foo");
+	gplugin_manager_add_app_paths(manager, prefix, "foo");
 
 	/* now get all the paths that the manager is managing and remove them from
 	 * our required table.
 	 */
-	paths = gplugin_manager_get_paths();
+	paths = gplugin_manager_get_paths(manager);
 	for(l = paths; l != NULL; l = l->next)
 		g_hash_table_remove(req, l->data);
 
